/*
  CPP_CONTEST=2013Cal-2011
  CPP_PROBLEM=R
  CPP_LANG=C+OPENMP+MPI
  CPP_PROCESSES_PER_NODE=marte 6 mercurio 6
*/

// 

/* RECORD
Alejandro Molina Zarca
student of Algorithms and Parallel programming
at the University of Murcia
January 30, 2012
time 3586 msec
speedup 5.90*/

/*RECORD in the new system
when the programs in the record table are run in the new system
formed by marte+mercurio (two hexacores),
it is the absolute record, with
time 1134
speed-up 10.32
*/

#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <mpi.h>
#include <omp.h>

#define NPOMP 1

typedef struct nodoarbol
{
	int* solucion;
	int* pesopormochila;
	int nivel;
} nodoarbol;

int** preparainicios(int mochilas,int objetos){
	int i=0,j=0;
	int **inicios = (int **)malloc(sizeof(int)*mochilas);
	for(i=0;i<objetos;i++){
		inicios[i] = (int *)malloc(sizeof(int)*objetos);
		inicios[i][0] = i-1;
		for(j=1;j<objetos;j++)
			inicios[i][j] = -1;
	}
	return inicios;
}

nodoarbol* preparanodos(int mochilas,int objetos,int* peso){
	int i=0,j=0;
	nodoarbol *nodos = (nodoarbol *)malloc(sizeof(nodoarbol)*mochilas);
	for(i=0;i<mochilas;i++){
		nodos[i].solucion = (int *)malloc(sizeof(int)*objetos);
		nodos[i].pesopormochila = (int *)malloc(sizeof(int)*mochilas);
		nodos[i].solucion[0] = i;
		nodos[i].pesopormochila[i] = peso[0];
		for(j=1;j<objetos;j++)
			nodos[i].solucion[j] = -1;
		for(j=0;j<mochilas;j++)
			if(i==j) continue;
			else nodos[i].pesopormochila[j]=0;
	}
/*	printf("SOLUCIONES INICIALES:\n");
	for(i=0;i<mochilas;i++){
		for(j=0;j<objetos;j++)
		printf("%d,",nodos[i].solucion[j]);
		printf("\n");
	}
	printf("PESOXMOCHILA INICIALES:\n");
	for(i=0;i<mochilas;i++){
		for(j=0;j<mochilas;j++)
		printf("%d,",nodos[i].pesopormochila[j]);
		printf("\n");
	}*/
	return nodos;
}

void genNodos(int *comb,int mochilas,int nivel){
	
	if(comb[nivel]<mochilas-1){
		comb[nivel]++;
	}else{
		comb[nivel]=0;
		genNodos(comb,mochilas,nivel-1);
	}

}

int compruebaPesos(int *comb,int mochilas,int nivel,int *peso,int *pesoxmoch,int *capacidad){

	//comb[i] en que mochila está objeto i
	//peso[i] peso objeto i
	int i=0;
	//Inicializamos el pero por mochila a 0
//	printf("CAPACIDADES:\n");
	for(i=0;i<mochilas;i++){
		pesoxmoch[i] = 0;
//		printf("%d,",capacidad[i]);
	}
//	printf("\n");
	for(i=0;i<nivel;i++){
		pesoxmoch[comb[i]]+=peso[i];
		//printf("CAPACIDAD TOTAL: %d, CARGA ACTUAL: %d\n",capacidad[comb[i]],pesoxmoch[comb[i]]);
		if(capacidad[comb[i]]<pesoxmoch[comb[i]])
			return 0;
	}
	return 1;
}

nodoarbol* preparanodos2(int mochilas,int objetos,int* peso,int* capacidad,int nnodos,int nivel,int *nodosreales){
	int i=0,j=0,cont=0;
	nodoarbol *nodos = (nodoarbol *)malloc(sizeof(nodoarbol)*nnodos);
	int *comb = (int *)malloc(sizeof(int)*objetos);
	int *pesoxmoch = (int *)malloc(sizeof(int)*mochilas);
	//printf("NIVEL DENTRO DE PREPARANODOS: %d\n",nivel);
	//printf("OBJETOS DENTRO DE PREPARANODOS: %d\n",objetos);
	for(i=0;i<objetos;i++){
		if(i<nivel)
			comb[i] = 0;
		else
			comb[i] = -1;
	}

	/*printf("COMB INICIAL:\n");
	for(i=0;i<objetos;i++){
			printf("%d,",comb[i]);
	}
	printf("\n");*/
	for(i=0;i<nnodos;i++){
		if(i>0)
		genNodos(comb,mochilas,nivel-1);
		if(compruebaPesos(comb,mochilas,nivel,peso,pesoxmoch,capacidad)==1){
			nodos[*nodosreales].solucion = (int *)malloc(sizeof(int)*objetos);
			nodos[*nodosreales].pesopormochila = (int *)malloc(sizeof(int)*mochilas);
			//printf("Nodo: %d\n",i);
			for(j=0;j<objetos;j++){
				nodos[*nodosreales].solucion[j]=comb[j];
				//printf("%d,",nodos[*nodosreales].solucion[j]);
			}
			//printf("\n");
			for(j=0;j<mochilas;j++){
				nodos[*nodosreales].pesopormochila[j]=pesoxmoch[j];
				//printf("%d,",nodos[*nodosreales].pesopormochila[j]);
			}
			//printf("\n");
			(*nodosreales)++;
		}else{
			//i--;
		}	
	}
	//printf("NODOS REALES: %d\n",*nodosreales);
	return nodos;
}


void pintanodos(int mochilas,int objetos,nodoarbol* nodos,int nnodos,int indice){
	int i=indice,j=0;
	printf("SOLUCIONES INICIALES:\n");
	for(i=0;i<nnodos;i++){
		for(j=0;j<objetos;j++)
		printf("%d,",nodos[i].solucion[j]);
		printf("\n");
	}
	printf("PESOXMOCHILA INICIALES:\n");
	for(i=0;i<nnodos;i++){
		for(j=0;j<mochilas;j++)
		printf("%d,",nodos[i].pesopormochila[j]);
		printf("\n");
	}
}

void pintanodo(int mochilas,int objetos,nodoarbol nodo){
	int i=0,j=0;
	printf("SOLUCIONES INICIALES:\n");
		for(j=0;j<objetos;j++)
		printf("%d,",nodo.solucion[j]);
		printf("\n");
	printf("PESOXMOCHILA INICIALES:\n");
		for(j=0;j<mochilas;j++)
		printf("%d,",nodo.pesopormochila[j]);
		printf("\n");
}

void pintasol(int mochilas,int objetos,nodoarbol nodoarbol){
	int i=0;
  printf("Solución\n");
  printf("En nivel %d\n",nodoarbol.nivel);
  printf("  solucion:");
  for(i=0;i<objetos;i++)
    printf(" %d ",nodoarbol.solucion[i]);
  printf("\n");
  printf("  pesos por mochila:");
  for(i=0;i<mochilas;i++)
    printf(" %d ",nodoarbol.pesopormochila[i]);
  printf("\n");
  printf("\n");
}
void enviaTodos(nodoarbol *nodos,int mochilas,int objetos,int nivel,int *peso,int *afinidad,int *capacidad,int *posact,int nodo,int np,int tag,int nnodos){
	int i,j,z;
		/*Se envia a todos el la información y el primer nodo correspondiente*/
		//printf("OBJETOS: %d, MOCHILAS: %d\n",objetos,mochilas);
		int tam=3+objetos+mochilas+(objetos*objetos);
		int *buffer = (int *)malloc(sizeof(int)*tam);
		int position=0;
		int root=0;
		int tamanio=0;
		tam = tam*sizeof(int);
		MPI_Pack_size(37, MPI_INT, MPI_COMM_WORLD, &tamanio);
		//printf("EL ESPACIO NECESARIO ES: %d\n",tamanio);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETANDO mochilas");		
		MPI_Pack(&mochilas,1,MPI_INT,buffer,tam,&position,MPI_COMM_WORLD);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETANDO objetos");	
		MPI_Pack(&objetos,1,MPI_INT,buffer,tam,&position,MPI_COMM_WORLD);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETANDO nivel");	
		MPI_Pack(&nivel,1,MPI_INT,buffer,tam,&position,MPI_COMM_WORLD);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETANDO peso");	
		MPI_Pack(peso,objetos,MPI_INT,buffer,tam,&position,MPI_COMM_WORLD);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETANDO afinidad");	
		MPI_Pack(afinidad,objetos*objetos,MPI_INT,buffer,tam,&position,MPI_COMM_WORLD);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETANDO capacidad");	
		MPI_Pack(capacidad,mochilas,MPI_INT,buffer,tam,&position,MPI_COMM_WORLD);
		//printf("%s%d%s\n", "PROCESO: ",nodo," EMPAQUETÓ TODO");	

		//printf("%s%d%s\n", "PROCESO: ",nodo," INTENTANDO ENVIAR A TODOS pakete");
		MPI_Bcast(buffer,tam,MPI_PACKED,root,MPI_COMM_WORLD);
	    //printf("%s%d%s\n", "PROCESO: ",nodo," ENVIÓ A TODOS pakete"); 

		free(buffer);
		tam= (objetos+mochilas)*NPOMP;
		//printf("NPOMP ES : %d Y TAM ES: %d\n",NPOMP,tam);
		buffer = (int *)malloc(sizeof(int)*tam);
		int tam2= tam*sizeof(int);
		int marca = -200;
		//printf("ENVIADOS: %d BYTES\n",tam);
		//printf("NP ES: %d\n",np);
		for(i=1;i<np;i++){
			position=0;
			for(j=0;j<NPOMP && (*posact)<nnodos;j++){
				MPI_Pack(nodos[*posact].solucion,objetos,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
				MPI_Pack(nodos[*posact].pesopormochila,mochilas,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);	
				//pintanodo(mochilas,objetos,nodos[*posact]);	
				(*posact)++;
			}
			if(j<NPOMP){
				//printf("EMPAQUETANDO MARCA\n");
				MPI_Pack(&marca,1,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
			}
			//printf("PROCESO: %d INTENTANDO ENVIAR %d NODOS A %d\n",nodo,j,i);
			MPI_Rsend(buffer,tam,MPI_INT,i,tag,MPI_COMM_WORLD);

		/*	printf("PROCESO: %d ENVIÓ %d NODOS A %d\n",nodo,j,i);
			for(z=0;z<j;z++)
				pintanodo(mochilas,objetos,nodos[z]);*/

			//printf("PROCESO: %d ENVIÓ %d NODOS A %d\n",nodo,j,i);
			//printf("NODOS ENVIADOS POR 0 A %d: %d\n",i,j);
			//pintanodos(mochilas,objetos,nodos,j,(*posact)-j);

		}

		free(buffer);

}

void recibeTodos(int *mochilas,int *objetos,int *nivel,int **peso,int **afinidad,int **capacidad,int nodo){
		
	int i,j,position;
	int tam=1000;
	int *buffer = (int *)malloc(sizeof(int)*tam);
	int root=0;
	/*Proceso recibe de 0 la información inicial*/
	//printf("%s%d%s\n", "PROCESO: ",nodo," INTENTANDO RECIBIR pakete");
	MPI_Bcast(buffer,tam,MPI_PACKED,root,MPI_COMM_WORLD);
    //printf("%s%d%s\n", "PROCESO: ",nodo," RECIBIÓ pakete");
    position=0;
     MPI_Unpack(buffer,tam,&position,mochilas,1,MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam,&position,objetos,1,MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam,&position,nivel,1,MPI_INT,MPI_COMM_WORLD);
	 *capacidad = (int *) malloc(sizeof(int)*(*mochilas));
     *peso=(int *) malloc(sizeof(int)*(*objetos));
     *afinidad = (int *) malloc(sizeof(int)*(*objetos)*(*objetos));
     MPI_Unpack(buffer,tam,&position,*peso,(*objetos),MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam,&position,*afinidad,(*objetos)*(*objetos),MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam,&position,*capacidad,(*mochilas),MPI_INT,MPI_COMM_WORLD);
}

void enviaFin(int nodo,int tag,int np){
	int fin=-100;
	int i=1;
		for(i=1;i<np;i++){
			//printf("%s%d%s%d\n", "PROCESO: ",nodo," INTENTANDO ENVIAR FIN A ",i);
			MPI_Rsend(&fin,1,MPI_INT,i,tag,MPI_COMM_WORLD);
			//printf("%s%d%s%d\n", "PROCESO: ",nodo," ENVIÓ FIN A ",i);
		}
		
}

void enviaNodo(nodoarbol *nodos,int mochilas,int objetos,int *posact,int nodo,int dest,int tag,int nodosreales){
	int i,z;
		int tam= (objetos+mochilas)*NPOMP;
		int *buffer = (int *)malloc(sizeof(int)*tam);
		int tam2 = tam*sizeof(int);
		int marca = -200;
		int	position=0;
		for(i=0;i<NPOMP && (*posact)<nodosreales;i++){
			MPI_Pack(nodos[*posact].solucion,objetos,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
			MPI_Pack(nodos[*posact].pesopormochila,mochilas,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
			//pintanodo(mochilas,objetos,nodos[*posact]);
			(*posact)++;
		}
		if(i<NPOMP){
			//printf("EMPAQUETANDO MARCA\n");
			MPI_Pack(&marca,1,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
		}		

		//printf("%s%d%s%d\n", "PROCESO: ",nodo," INTENTANDO ENVIAR NODO A ",dest);
		MPI_Rsend(buffer,tam,MPI_INT,dest,tag,MPI_COMM_WORLD);
		//printf("%s%d%s%d\n", "PROCESO: ",nodo," ENVIÓ NODO A ",dest);

		free(buffer);
		//printf("NODOS ENVIADOS POR 0 A %d: %d\n",dest,i);
			//pintanodos(mochilas,objetos,nodos,i,(*posact)-i);
		
}

void recibeNodo(nodoarbol *nodos,int mochilas,int objetos,int nodo,int tag,MPI_Status status,int *fin,int *nnodos){

	int i,j,position;
	int tam=(objetos+mochilas)*NPOMP;
	int *buffer = (int *)malloc(sizeof(int)*tam);
	int tam2 = tam*sizeof(int);
	//printf("PRETENDO RECIBIR: %d BYTES\n",tam);
	/*Proceso recibe de 0 la información inicial*/
	//printf("%s%d%s\n", "PROCESO: ",nodo," INTENTANDO RECIBIR nodos");
	MPI_Recv(buffer,tam,MPI_INT,0,tag,MPI_COMM_WORLD,&status);
    //printf("%s%d%s\n", "PROCESO: ",nodo," RECIBIÓ nodos");

	//printf("NPOMP ES : %d\n",NPOMP);

	if(buffer[0]==-100){
		(*fin)=1;
	}else{
		//printf("PROCESO: %d RECIBE NODOS:\n",nodo);
		position=0;
		for(j=0;j<NPOMP;j++){
			//printf("BUFFER[%d] EN NODO %d ES %d\n",j*(objetos+mochilas),nodo,buffer[j*(objetos+mochilas)]);
			if(buffer[j*(objetos+mochilas)]==-200){
				(*nnodos)=j;
				//printf("PROCESO: %d RECIBIDA MARCA TRAS %d NODOS\n",nodo,*nnodos);
				break;
			 }else{
				MPI_Unpack(buffer,tam2,&position,nodos[j].solucion,objetos,MPI_INT,MPI_COMM_WORLD);
			 	MPI_Unpack(buffer,tam2,&position,nodos[j].pesopormochila,mochilas,MPI_INT,MPI_COMM_WORLD);					
				//pintanodo(mochilas,objetos,nodos[j]);
			}
		}	
		*nnodos=j;

		/*printf("PROCESO %d RECIBIO NODOS:\n",nodo);
		for(i=0;i<*nnodos;i++)
			pintanodo(mochilas,objetos,nodos[i]);*/
		//printf("NODOS RECIBIDOS POR %d\n",nodo);
		//pintanodos(mochilas,objetos,nodos,*nnodos);
	}
	free(buffer);

}

void enviaSol(nodoarbol *nodoact,int mochilas,int objetos,int nodo,int solucion,int tag){
	int i;
	int tam= objetos+mochilas+2;
	int *buffer = (int *)malloc(sizeof(int)*tam);
	int tam2 = tam*sizeof(int);
	int	position=0;

	MPI_Pack(nodoact->solucion,objetos,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
	MPI_Pack(nodoact->pesopormochila,mochilas,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
	MPI_Pack(&solucion,1,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);
	MPI_Pack(&nodoact->nivel,1,MPI_INT,buffer,tam2,&position,MPI_COMM_WORLD);

	//printf("%s%d%s%d\n", "PROCESO: ",nodo," INTENTANDO ENVIAR SOLUCION PARCIAL A ",0);
	MPI_Rsend(buffer,tam,MPI_INT,0,tag,MPI_COMM_WORLD);
	//printf("%s%d%s%d\n", "PROCESO: ",nodo," ENVIÓ SOLUCION PARCIAL A ",0);

	free(buffer);
}

void recibeSol(nodoarbol *nodoact,int *solucion,int mochilas,int objetos,int nodo,int *dest,int tag,MPI_Status status){
	int i,j,position;
	int tam=objetos+mochilas+2;
	int *buffer = (int *)malloc(sizeof(int)*tam);
	int tam2 = tam*sizeof(int);
	/*Proceso 0 recibe solucion parcial*/
	//printf("%s%d%s\n", "PROCESO: ",nodo," INTENTANDO RECIBIR SOLUCION PARCIAL");
	MPI_Recv(buffer,tam,MPI_INT,MPI_ANY_SOURCE,tag,MPI_COMM_WORLD,&status);
    //printf("PROCESO: %d RECIBIÓ SOLUCION PARCIAL DE : %d\n",nodo,status.MPI_SOURCE);
	*dest = status.MPI_SOURCE;
    position=0;
     MPI_Unpack(buffer,tam2,&position,nodoact->solucion,objetos,MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam2,&position,nodoact->pesopormochila,mochilas,MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam2,&position,solucion,1,MPI_INT,MPI_COMM_WORLD);
     MPI_Unpack(buffer,tam2,&position,&nodoact->nivel,1,MPI_INT,MPI_COMM_WORLD);
	free(buffer);
}

void evaluaSol(int mochilas,int objetos,int solucion,int *max,nodoarbol *nodoact,nodoarbol *mejornodo){
	//printf("EN EVALUASOL SOL: %d\n",solucion);
	if(solucion>(*max)){
		(*max)=solucion;
		mejornodo->nivel = nodoact->nivel;
		mejornodo->solucion = nodoact->solucion;
		mejornodo->pesopormochila = nodoact->pesopormochila;
		nodoact->solucion = (int *)malloc(sizeof(int)*objetos);
		nodoact->pesopormochila = (int *)malloc(sizeof(int)*mochilas);
	}

}

void pintaInfo(int mochilas,int objetos,int nivel,int *peso,int *afinidad,int *capacidad,int nodo){
		int i=0,j=0;	
		printf("NODO: %d RECIBIO MOCHILAS: %d, OBJETOS: %d, NIVEL %d\n",nodo,mochilas,objetos,nivel);
		printf("PESOS:\n");
		for(i=0;i<objetos;i++)
			printf("%d,",peso[i]);
		printf("\nAFINIDADES:\n");
		for(i=0;i<objetos;i++){
			for(j=0;j<objetos;j++)
				printf("%d,",afinidad[i*objetos+j]);
			printf("\n");
		}
		printf("CAPACIDADES:\n");
		for(i=0;i<mochilas;i++)
			printf("%d,",capacidad[i]);
		printf("\n");
}

sec(int mochilas,int objetos,int *capacidad,int *peso,int *afinidad,int nodo,int np){
	int solucion;
  	int tag=0;
  	MPI_Status status; 
	//int np2 = omp_get_max_threads();
  	int np2=np*NPOMP;  //numero de threads
	int nivel = 0; //nivel al que debe llegar el primer caso.
	int z = 0; //indice
	int max=0; //variable que contiene el mejor resultado
	int sol=0; //indice de array de nodos que contiene la solucion
	double loga=0.0;
	int nnodos=0;
	int nodosreales=0;
	struct nodoarbol *nodos; 
	struct nodoarbol nodoact;
	struct nodoarbol mejornodo;
	if(nodo==0){		
		int posact=0;
		int dest=0;
		nodoact.solucion = (int *)malloc(sizeof(int)*objetos);
		nodoact.pesopormochila = (int *)malloc(sizeof(int)*mochilas);
		//printf("NP=%d * %d OMP MOCHILAS=%d\n",np,NPOMP,mochilas);
		if(np2>mochilas){ //Debemos generar nodos hasta cumplir mochilas^x>=np2
			nivel = round(log((double)np2)/log((double)mochilas));
			if(pow((double)mochilas,(double)nivel)<np2){
				nivel++;
			}
			nnodos = pow((double)mochilas,(double)nivel);
			//printf("NODOS MAXIMOS: %d\n",nnodos);
			//printf("NIVEL ES: %d\n",nivel);
			while(nodosreales<np2){
				nodosreales=0;
				nodos = preparanodos2(mochilas,objetos,peso,capacidad,nnodos,nivel,&nodosreales);
				if(nodosreales<np2){
					//printf("NODOS REALES TRAS PREPARACION: %d, INCREMENTANDO NIVEL\n",nodosreales); 
					nivel++;
					nnodos = pow((double)mochilas,(double)nivel);
				}
			}		
			//printf("NODOS REALES: %d\n",nodosreales);
			//pintanodos(mochilas,objetos,nodos,nodosreales,0);
			//printf("CASO NP>MOCHILAS\n");
			//MPI_Barrier(MPI_COMM_WORLD);
			solucion=0;
			nivel--; //tenemos que enviar nivel-1
		} 
		
		if(np2==mochilas){ 	//Preparamos tantos nodos como mochilas
			//printf("CASO NP==MOCHILAS\n");
			nnodos=mochilas;
			nodos = preparanodos(mochilas,objetos,peso);
			//pintanodos(mochilas,objetos,peso,nodos,mochilas);
			//MPI_Barrier(MPI_COMM_WORLD);
		} 
		if(np2<mochilas){ 	//Preparamos tantos nodos como mochilas
			nnodos=mochilas;
			nodos = preparanodos(mochilas,objetos,peso);
			//pintanodos(mochilas,objetos,peso,nodos,mochilas);
			//printf("CASO NP<MOCHILAS\n");
			//MPI_Barrier(MPI_COMM_WORLD);
		} 
			if(nodosreales!=0)
				nnodos=nodosreales;
			//Enviar a todos los procesos
			enviaTodos(nodos,mochilas,objetos,nivel,peso,afinidad,capacidad,&posact,nodo,np,tag,nnodos);
			//printf("POSACT: %d\n",posact);
		/*	recibeSol(&nodoact,&solucion,mochilas,objetos,nodo,&dest,tag,status);
			evaluaSol(mochilas,objetos,solucion,&max,&nodoact,&mejornodo);
			enviaNodo(nodos,mochilas,objetos,&posact,nodo,dest,tag);
			enviaFin(nodo,tag,np);*/

			while(posact<nnodos){
				//Esperar solucion parcial
				recibeSol(&nodoact,&solucion,mochilas,objetos,nodo,&dest,tag,status);
				//EvaulaSol
				evaluaSol(mochilas,objetos,solucion,&max,&nodoact,&mejornodo);
				//EnviaNodo
				enviaNodo(nodos,mochilas,objetos,&posact,nodo,dest,tag,nnodos);
			}
			for(z=1;z<np;z++){
				recibeSol(&nodoact,&solucion,mochilas,objetos,nodo,&dest,tag,status);
				evaluaSol(mochilas,objetos,solucion,&max,&nodoact,&mejornodo);
			}
			enviaFin(nodo,tag,np);
			solucion=max;
			//printf("MEJOR SOLUCION EN NODO 0:\n");
			//pintasol(mochilas,objetos,mejornodo);
			/*pintasol(mochilas,objetos,mejornodo);
			for(z=0;z<mochilas;z++){
				free(nodos[z].solucion);
				free(nodos[z].pesopormochila);
			}*/
			//MPI_Barrier(MPI_COMM_WORLD);
		return solucion;
	}
	/*Lo que deben hacer el resto de nodos*/

	if(nodo!=0){
		int fin=0;
		int nnodos=0;
		nodoarbol *nodos = (nodoarbol *)malloc(sizeof(nodoarbol)*NPOMP);
		//Reciben la información necesaria
		recibeTodos(&mochilas,&objetos,&nivel,&peso,&afinidad,&capacidad,nodo);	
		for(z=0;z<NPOMP;z++){
			nodos[z].solucion = (int *)malloc(sizeof(int)*objetos);
			nodos[z].pesopormochila = (int *)malloc(sizeof(int)*mochilas);	
		}
		//recibeNodo(nodos,mochilas,objetos,nodo,tag,status,&fin,&nnodos);
		//pintaInfo(mochilas,objetos,nivel,peso,afinidad,capacidad,nodo);
		while(1){
			//Recibir nodo
			nnodos=0;
			//solucion=0;
			//max=0;
			recibeNodo(nodos,mochilas,objetos,nodo,tag,status,&fin,&nnodos);
			/*printf("PROCESO %d RECIBIO NODOS:\n",nodo);
			for(z=0;z<nnodos;z++)
				pintanodo(mochilas,objetos,nodos[z]);*/
			if(fin==1) break;
			//ejecutar
			//solucion=mochila(mochilas,objetos,capacidad,peso,afinidad,nodo,np,&nodoact,nivel);
			omp_set_num_threads(NPOMP);
			#pragma omp parallel private(z,solucion)
			{
				#pragma omp for
				for(z=0;z<nnodos;z++){
					solucion=mochila2(mochilas,objetos,capacidad,peso,afinidad,nodo,np,&nodos[z],nivel);
					#pragma omp critical
					{
						if(solucion>max){
							//printf("ENCONTRADA SOLUCION QUE MEJORA SIENDO DE: %d\n",solucion);
							max=solucion;
							sol=z;
						}
					}
				}
			}
			if(z>0){
				solucion=max;
				//printf("SOLUCION APORTADA POR NODO %d\n",nodo);
				//pintasol(mochilas,objetos,nodos[sol]);
				//printf("%d\n",solucion);
				//enviaSol()
				enviaSol(&nodos[sol],mochilas,objetos,nodo,solucion,tag);
			}
		}
	}



}


 
void copiasol(int *solucion,int*solucionmax,int *pesopormochila,int *pesopormochilamax,int objetos,int mochilas,int nivel,int *nivelsol){

	int i=0;
	for(i=0;i<objetos;i++)
		solucionmax[i]=solucion[i];
	for(i=0;i<mochilas;i++)
		pesopormochilamax[i]=pesopormochila[i];
	*nivelsol=nivel;
}


void generar(int nivel,int *peso,int *solucion,int *pesopormochila)
{
  if(solucion[nivel]!=-1)
  {
    pesopormochila[solucion[nivel]]-=peso[nivel];
  }

  solucion[nivel]++;  
  pesopormochila[solucion[nivel]]+=peso[nivel];
}

int essolucion(int nivel,int objetos,int *capacidad,int *pesopormochila,int *solucion)
{
  return((nivel==objetos-1) && pesopormochila[solucion[nivel]]<=capacidad[solucion[nivel]]);
}
    
int calcularvalor(int objetos,int *solucion,int *afinidad)
{
  int valor=0,i,j;

  for(i=0;i<objetos;i++)
  {
    for(j=i+1;j<objetos;j++)
    {
      if(solucion[i]==solucion[j])
      {
		//printf("En bucle calculando valor es %d\n",valor);
        valor+=(afinidad[i*objetos+j]+afinidad[j*objetos+i]);
      }
    }
  }
  return valor;
}

int criterio(int nivel,int objetos,int *capacidad,int *solucion,int *pesopormochila)
{
  return(nivel!=objetos-1 && pesopormochila[solucion[nivel]]<=capacidad[solucion[nivel]]);
}

int mashermanos(int nivel,int mochilas,int *solucion)
{
  return(solucion[nivel]<mochilas-1);
}

void retroceder(int nivel,int mochilas,int *peso,int *solucion,int *pesopormochila)
{
  pesopormochila[mochilas-1]-=peso[nivel];
  solucion[nivel]=-1;  
}

void escribir(int nivel,int mochilas,int objetos,int *capacidad,int *peso,int *afinidad,int *solucion,int *pesopormochila)
{
  int i,seguir;

  printf("En nivel %d\n",nivel);
  printf("  solucion:");
  for(i=0;i<objetos;i++)
    printf(" %d ",solucion[i]);
  printf("\n");
  printf("  pesos por mochila:");
  for(i=0;i<mochilas;i++)
    printf(" %d ",pesopormochila[i]);
  printf("\n");
  printf("\n");
}

int mochila2(int mochilas,int objetos,int *capacidad,int *peso,int *afinidad,int nodo,int np,nodoarbol *nodoarbol,int nini)
{
  int *solucion,*pesopormochila,valor=0,VOA=0,i,nivel=0,flag=1,vini=0;
  int *solucionmax,*pesopormochilamax,nivelsol;
  solucionmax=(int *) malloc(sizeof(int)*objetos);
  pesopormochilamax=(int *) malloc(sizeof(int)*mochilas);
	/*solucion y pesoxmochila inicialmente son los del nodo que recibe*/
	solucion = nodoarbol->solucion;
	pesopormochila = nodoarbol->pesopormochila;
	/*Guardamos el valor del ultimo entero distinto de -1 en vini y el nivel inicial*/
	vini=solucion[nini];
	nivel=nini;

  //printf("Tras Inicializar\n");
  //escribir(nivel,mochilas,objetos,capacidad,peso,afinidad,solucion,pesopormochila);
  do{
	/*La primera vez no generamos*/
	if(flag==0)
    	generar(nivel,peso,solucion,pesopormochila);
	flag=0;
	/*Si el valor de la posicion que almacenamos ha sido modificado terminamos*/
	if(solucion[nini]!=vini) break;
  //printf("Tras Generar\n");
  //escribir(nivel,mochilas,objetos,capacidad,peso,afinidad,solucion,pesopormochila);
    if(essolucion(nivel,objetos,capacidad,pesopormochila,solucion)==1)
    {
      valor=calcularvalor(objetos,solucion,afinidad);
      if(valor>VOA)
      {  VOA=valor;
		copiasol(solucion,solucionmax,pesopormochila,pesopormochilamax,objetos,mochilas,nivel,&nivelsol);
  		//printf("Tras Essolucion, valor %d\n",valor);
  		//escribir(nivel,mochilas,objetos,capacidad,peso,afinidad,solucion,pesopormochila);
      }
    }
    if(criterio(nivel,objetos,capacidad,solucion,pesopormochila)==1)
    {
  //printf("Tras Criterio\n");
  //escribir(nivel,mochilas,objetos,capacidad,peso,afinidad,solucion,pesopormochila);
      nivel++;
    }
    else
    {
      while(nivel!=-1 && mashermanos(nivel,mochilas,solucion)==0)
      {
  //printf("Tras Mashermanos\n");
  //escribir(nivel,mochilas,objetos,capacidad,peso,afinidad,solucion,pesopormochila);
        retroceder(nivel,mochilas,peso,solucion,pesopormochila);
        nivel--;
  //printf("Tras Retroceder\n");
  //escribir(nivel,mochilas,objetos,capacidad,peso,afinidad,solucion,pesopormochila);
      }
    }
  } while(nivel!=-1);

  //printf("Solución\n");
  //escribir(nivelsol,mochilas,objetos,capacidad,peso,afinidad,solucionmax,pesopormochilamax);

  nodoarbol->solucion=solucionmax;
  nodoarbol->pesopormochila=pesopormochilamax;
  nodoarbol->nivel=nivelsol;
  //free(solucionmax);
  //free(pesopormochilamax);


  free(solucion);
  free(pesopormochila);
  return VOA;
}


